//
//  PhotoStacks_AppDelegate.h
//  PhotoStacks
//
//  Created by Scott Stevenson on 10/11/07.
//  Released under a BSD-style license. See License.txt
//

#import <Cocoa/Cocoa.h>
#import "THCanvasView.h"

@interface PhotoStacks_AppDelegate : NSObject 
{
    IBOutlet NSWindow* window;
    IBOutlet NSArrayController* itemsController;
    IBOutlet THCanvasView* canvasView;

    unsigned _itemWidth;
    NSMutableArray* _canvasItems;
    
    NSPersistentStoreCoordinator *persistentStoreCoordinator;
    NSManagedObjectModel *managedObjectModel;
    NSManagedObjectContext *managedObjectContext;
}

- (NSPersistentStoreCoordinator *)persistentStoreCoordinator;
- (NSManagedObjectModel *)managedObjectModel;
- (NSManagedObjectContext *)managedObjectContext;

- (IBAction)saveAction:sender;


#pragma mark Accessors

- (unsigned)itemWidth;
- (void)setItemWidth:(unsigned)newItemWidth;

- (NSMutableArray *)canvasItems;
- (void)setCanvasItems:(NSMutableArray *)aValue;

@end
